
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CABBAGE CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2)
#define BASIC colour(56, 150, 180, 255) trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define RSLIDER colour(56, 150, 180, 255) trackerColour("MediumTurquoise") fontColour("Gainsboro") valueTextBox(1) textBoxColour("black") 
#define FONT fontColour("Gainsboro")

;MAIN GUI:
form caption("SFilter") channel("f1") size(855,785) pluginId("SF01") colour(76,130,180,155) guiMode("queue") fontColour("Gainsboro") ;style("legacy") 

label channel("l51") bounds(5,5,80,20) text("Presets") $FONT
combobox bounds(80,5,175,20) populate("*.snaps") channelType("string") channel("cb1") value(1) ;$FONT
filebutton bounds(260,5,35,20) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(300,5,50,20) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1) 

label channel("l52") bounds(355,5,50,20) text("Input") $FONT
button bounds(410,5,60,20) channel("liveon") text("Mic/Line") $BUTTONS
combobox bounds(470,5,60,20) channel("livech") text("Stereo","Mono") value(1)
rslider bounds(525,0,60,40) channel("liveamp") range(0,5,.75,0.75,0.001) $RSLIDER
filebutton bounds(590,5,75,20) channel("openFile") text("Load SF") $BUTTONS
button bounds(670,5,45,20) channel("sfplay") text("Play") $BUTTONS
button bounds(720,5,45,20) channel("sfloop") text("Loop") $BUTTONS
rslider bounds(760,0,60,40) channel("sfamp") range(0,5,.75,0.75,0.001) $RSLIDER

image channel("ifilter") bounds(5,50,470,730) plant("Filter") $PLANT
{
button bounds(5,5,95,40) channel("filt") latched(1) text("spectral filter") $BUTTONS
label bounds(105,5,25,15) channel("lf1") text("in") $FONT
combobox bounds(135,5,70,20) channel("filtsource") items("mic/line","soundfile","warp","morph","devolve","trace") value(1)

label bounds(205,5,260,15) channel("lf2") text("functions sum to create the filter") $FONT
label bounds(205,20,260,15) channel("lf2") text("(bottom image) that is then") $FONT
label bounds(205,35,260,15) channel("lf2") text("sent through the bandpass") $FONT

label bounds(5,55,115,18) channel("l6") text("Line") $FONT
label bounds(105,55,50,15) channel("l7") text("start") $FONT
label bounds(185,55,50,15) channel("l8") text("end") $FONT
label bounds(265,55,50,15) channel("l9") text("F") $FONT
rslider bounds(130,55,65,45) channel("offsetstart") range(.001,1,.5,1,.001) $RSLIDER
rslider bounds(210,55,65,45) channel("offsetend") range(.001,1,.5,1,.001) $RSLIDER
rslider bounds(290,55,65,45) channel("lineF") range(1,250,1,1,.1) $RSLIDER

button bounds(25,105,75,25) channel("rgen") latched(0) text("Random") $BUTTONS
label bounds(25,135,50,15) channel("l22") text("amp") $FONT
rslider bounds(50,135,65,45) channel("nzscale") range(0,1,0,1,0.001) $RSLIDER
gentable bounds(110,105,355,75) channel("rand1") tableNumber(200) ampRange(0,1,200,.001) outlineThickness(2) $FTABLES

button bounds(25,200,75,25) channel("walk") latched(1) text("random walk") $BUTTONS
button bounds(25,230,75,25) channel("wreset") latched(0) text("reset") $BUTTONS
label bounds(25,260,50,15) channel("l24") text("amp") $FONT
label bounds(100,200,50,15) channel("l25") text("depth") $FONT
label bounds(100,260,50,15) channel("l24") text("speed") $FONT
rslider bounds(50,260,65,45) channel("wscale") range(0,1,0,1,0.001) $RSLIDER 
rslider bounds(140,200,65,45) channel("wdepth") range(0,1,0,1,0.001) $RSLIDER 
rslider bounds(140,260,65,45) channel("wrate") range(.1,50,5,1,0.1) $RSLIDER 
gentable bounds(200,200,265,75) channel("walktest") tableNumber(300) ampRange(-.5,.5,300,.001) outlineThickness(2) $FTABLES ;identChannel("table300") 

label bounds(5,325,115,18) channel("l3") text("Harmonic") $FONT
label bounds(5,345,115,18) channel("l3") text("Filter") $FONT
label bounds(25,365,50,15) channel("l11") text("amp") $FONT
rslider bounds(50,365,65,45) channel("sinamp") range(0,1,0,1,.001) $RSLIDER
label bounds(25,415,50,15) channel("l10") text("F") $FONT
rslider bounds(50,415,75,45) channel("sinF") range(0,20000,20,.5,.1) $RSLIDER
label bounds(95,415,75,15) channel("l34") text("spread") $FONT
rslider bounds(140,415,65,45) channel("spread") range(1,500,25,1,.1) $RSLIDER
label bounds(180,415,75,15) channel("l33") text("ctr harm") $FONT
rslider bounds(230,415,65,45) channel("ctrh") range(-200,200,1,1,.1) $RSLIDER
label bounds(315,415,20,15) channel("l15") text("Q") $FONT
rslider bounds(320,415,65,45) channel("Q") range(.5,100,1,.5,.01) $RSLIDER
label bounds(400,415,25,15) channel("l35") text("oct") $FONT
rslider bounds(410,415,65,45) channel("oct") range(1,4,1,1,.01) $RSLIDER
gentable bounds(120,325,345,75) channel("cos") tableNumber(401) ampRange(0,1,401,.001) outlineThickness(2) $FTABLES

label bounds(5,480,115,18) channel("l5") text("Rotate") $FONT
rslider bounds(90,480,65,45) channel("rotate") range(0,1,0,1,.0001) $RSLIDER
label bounds(130,480,200,18) channel("l13") text("Portamento Time") $FONT
rslider bounds(300,480,65,45) channel("port") range(.01,10,.1,.5,.01) $RSLIDER

gentable bounds(10,535,450,135) channel("arraydisplayL") tableNumber(99) ampRange(0,1,99,.001) outlineThickness(2) $FTABLES ;identChannel("table99")

label bounds(5,680,35,18) channel("lbp1") text("BP") $FONT
label bounds(35,680,45,15) channel("lbp2") text("lo F") $FONT
label bounds(100,680,45,15) channel("lbp3") text("ramp") $FONT
label bounds(175,680,45,15) channel("lbp4") text("hi F") $FONT
label bounds(240,680,45,15) channel("lbp5") text("ramp") $FONT
rslider bounds(50,680,75,45) channel("lo") range(0,20000,20,.5,.1) $RSLIDER
rslider bounds(120,680,75,45) channel("lw") range(0,20000,20,.5,.1) $RSLIDER
rslider bounds(190,680,75,45) channel("hi") range(0,22000,20000,.5,.1) $RSLIDER
rslider bounds(260,680,75,45) channel("hw") range(0,22000,2000,.5,.1) $RSLIDER

label bounds(300,680,75,18) channel("l12") text("Mix") $FONT
rslider bounds(340,680,65,45) channel("fmix") range(0,1,1,1,.01) $RSLIDER
label bounds(370,680,75,18) channel("lfilto") text("out") $FONT
rslider bounds(410,680,65,45) channel("fout") range(0,2,1,1,.01) $RSLIDER
}

image channel("ifreeze") bounds(480,50,370,75) plant("Freeze") $PLANT
{
button bounds(5,5,95,20) channel("grab") latched(1) text("freeze/warp") $BUTTONS
button bounds(5,30,95,20) channel("grabs") latched(1) text("stream/warp") $BUTTONS
label bounds(5,55,20,15) channel("lw5") text("in") $FONT
combobox bounds(30,52,70,20) channel("frzsource") items("mic/line","soundfile","filter","morph","devolve","trace") value(1)
label bounds(120,5,50,15) channel("lw1") text("scale") $FONT
rslider bounds(115,25,65,45) channel("warpsc") range(.125,8,1,.33,.001) $RSLIDER
label bounds(170,5,50,15) channel("lw2") text("shift") $FONT
rslider bounds(165,25,65,45) channel("warpsh") range(-5000,5000,0,1,1) $RSLIDER
label bounds(220,5,50,15) channel("lw3") text("low") $FONT
rslider bounds(215,25,65,45) channel("warplo") range(0,5000,0,1,1) $RSLIDER
label bounds(270,5,50,15) channel("lw4") text("mix") $FONT
rslider bounds(265,25,65,45) channel("warpmix") range(0,1,1,1,.01) $RSLIDER
label bounds(320,5,50,15) channel("lw6") text("out") $FONT
rslider bounds(315,25,65,45) channel("wout") range(0,2,1,1,.01) $RSLIDER
}

image channel("imorph") bounds(480,130,370,280) plant("Morph") $PLANT
{
button bounds(5,5,95,40) channel("morph") latched(1) text("freeze/morph") $BUTTONS
label bounds(5,55,20,15) channel("lm1") text("in") $FONT
combobox bounds(30,52,70,20) channel("morphsource") items("mic/line","soundfile","filter","warp","devolve","trace") value(1)
label bounds(5,90,95,15) channel("lm2") text("grab corners") $FONT
button bounds(5,110,45,45) channel("grab1") latched(0) text("1") $BUTTONS
button bounds(55,110,45,45) channel("grab2") latched(0) text("2") $BUTTONS
button bounds(5,160,45,45) channel("grab3") latched(0) text("3") $BUTTONS
button bounds(55,160,45,45) channel("grab4") latched(0) text("4") $BUTTONS
label bounds(25,215,50,15) channel("lg1") text("out") $FONT
rslider bounds(18,230,65,45) channel("mout") range(0,2,1,1,.01) $RSLIDER
xypad bounds(105,5,250,270) channel("morphx","morphy") rangeX(0,1,.5) rangeY(0,1,.5) colour("Gainsboro") 

}

image channel("idev") bounds(480,415,370,225) plant("Devolve") $PLANT
{
button bounds(5,5,95,40) channel("dev") latched(1) text("devolve") $BUTTONS
label bounds(5,50,20,15) channel("ld1") text("in") $FONT
combobox bounds(30,50,70,20) channel("devsource") items("mic/line","soundfile","filter","warp","morph","trace") value(1)
button bounds(205,5,95,40) channel("devt") latched(0) text("timed devolve") $BUTTONS
combobox bounds(105,50,95,20) channel("freeze") items("freeze","stream") value(2)
combobox bounds(205,50,95,20) channel("dir") items("forwards","backwards") value(1)
combobox bounds(205,75,95,20) channel("linex") items("linear","exponential","manual") value(3)
checkbox bounds(12,95,25,25) channel("damp") value(1) colour("MediumTurquoise")
checkbox bounds(12,145,25,25) channel("df") value(1) colour("MediumTurquoise")
label bounds(5,75,35,15) channel("l41") text("amp") $FONT
label bounds(5,125,35,15) channel("l42") text("freq") $FONT
label bounds(300,5,65,15) channel("l47") text("dur") $FONT
rslider bounds(300,20,65,40) channel("dtime") range(.1,600,15,1,.1) $RSLIDER
label bounds(300,65,65,15) channel("l48") text("att/dec") $FONT
rslider bounds(300,80,65,40) channel("ad") range(.001,30,.5,1,.001) $RSLIDER
label bounds(55,75,40,15) channel("l43") text("min") $FONT
rslider bounds(40,90,75,45) channel("dminA") range(-1,4,-.01,1,.0001) $RSLIDER ;dB
label bounds(110,75,45,15) channel("l44") text("max") $FONT
rslider bounds(95,90,75,45) channel("dmaxA") range(-1,4,.01,1,.0001) $RSLIDER
rslider bounds(40,140,75,45) channel("dminF") range(-48,48,-1,1,.1) $RSLIDER ;expressed as semitones
rslider bounds(95,140,75,45) channel("dmaxF") range(-48,48,1,1,.1) $RSLIDER
label bounds(150,100,65,15) channel("l48") text("exp") $FONT
rslider bounds(150,115,65,40) channel("exp") range(.25,4,2,.5,.01) $RSLIDER

label bounds(200,125,65,15) channel("lmanport") text("port") $FONT
rslider bounds(200,140,65,45) channel("manport") range(.01,5,.1,.5,.01) $RSLIDER
label bounds(250,125,65,15) channel("ld1") text("mix") $FONT
rslider bounds(250,140,65,45) channel("devmix") range(0,1,1,1,.01) $RSLIDER
label bounds(300,125,65,15) channel("ld2") text("out") $FONT
rslider bounds(300,140,65,45) channel("dout") range(0,2,1,1,.01) $RSLIDER
hslider bounds(5,200,360,20) channel("manual") range(0,1,0,1,.001) $RSLIDER
}

image channel("itrace") bounds(480,645,370,75) plant("Trace") $PLANT
{
button bounds(5,5,95,40) channel("trace") latched(1) text("trace") $BUTTONS
label bounds(5,55,20,15) channel("lt1") text("in") $FONT
combobox bounds(30,52,70,20) channel("tracesource") items("mic/line","soundfile","filter","warp","morph","devolve") value(1)

label bounds(92,5,55,15) channel("l49") text("bins") $FONT
rslider bounds(92,25,65,45) channel("tbins") range(1,1000,25,.5,1) $RSLIDER
label bounds(132,8,65,13) channel("l50") text("gr dur") $FONT
rslider bounds(137,25,65,40) channel("grdur") range(.25,25,.5,1,.01) $RSLIDER
label bounds(187,8,55,13) channel("l51") text("overlap") $FONT
rslider bounds(182,25,65,40) channel("overlap") range(2,25,8,1,.01) $RSLIDER
label bounds(230,8,55,13) channel("l51") text("rand") $FONT
rslider bounds(227,25,65,40) channel("trand") range(0,.95,.1,1,.01) $RSLIDER
label bounds(280,5,45,15) channel("l52") text("mix") $FONT
rslider bounds(270,25,65,45) channel("tmix") range(0,1,1,1,.01) $RSLIDER
label bounds(325,5,45,15) channel("l53") text("out") $FONT
rslider bounds(315,25,65,45) channel("tout") range(0,2,1,1,.01) $RSLIDER
}

image channel("irec") bounds(480,725,370,55) plant("Record") $PLANT
{
label bounds(5,5,120,20) channel("rl1") text("record input") $FONT
combobox bounds(5,30,115,20) channel("rsource") items("filter","freeze","morph","devolve","trace","mic/line","soundfile") value(1)
button bounds(125,5,75,45) channel("record") text("Record","Stop") colour("red") fontColour("white")
combobox bounds(205,5,80,20) channel("recch") value(2) text("mono","stereo","split stereo") value(1)
combobox bounds(205,30,80,20) channel("bit") value(1) text("16-bit","24-bit","32-bit") value(1)
button bounds(290,5,75,45), channel("play") text("Play") colour("green") fontColour("white") value(0)
}
</Cabbage>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CSOUND CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 --displays ;sends MIDI note number and velocity to instr 1 as p4 and p5 respectively
</CsOptions>
<CsInstruments>

; Initialize the global variables. 
gisr=sr
ksmps = 100
nchnls = 2
0dbfs = 1

gkstatus,gkchan,gkdata1,gkdata2 init 0 ;initialize global MIDI settings
gichnls init 0 ;globals for soundfile table loading
giReady init 0
gSfilepath init ""
gkTabLen init 2
giTable init 601
gkRecordingActiveFlag,gkFileRecorded init 0
gafiltL,gafiltR,gafreezeL,gafreezeR,gamorphL,gamorphR,gadevL,gadevR,gatraceinL,gatraceinR,gatraceL,gatraceR init 0 ;gafinalL,gafinalR,
gamicL,gamicR,gasfL,gasfR init 0
gisize init 2048
gkNz[] init gisize
gkRandcurrent[] init gisize
gkRandtarget[] init gisize
gkmorph init 0 ;use to prompt re-summing in i10 if i6 is running
gkWalk[] init gisize
gkWtemp[] init gisize
gkWcurrent [] init gisize
gkWtarget[] init gisize
gkHfilt[] init gisize
gktrig,gkmicsfenv init 0
;set up all the arrays needed to be able to provide any array input into instruments 15-16, 25-31 and 40-41
gkBinsL[] init gisize+2
gkBinsR[] init gisize+2
gkFiltL[] init gisize+2
gkFiltR[] init gisize+2
gkGrabL[] init gisize+2
gkGrabR[] init gisize+2
gkFrzL[] init gisize+2
gkFrzR[] init gisize+2
gkMorphL[] init gisize+2
gkMorphR[] init gisize+2
gkDevL[] init gisize+2
gkDevR[] init gisize+2
gkTraceL[] init gisize+2
gkTraceR[] init gisize+2
gkMicL[] init gisize+2
gkMicR[] init gisize+2
gkSfL[] init gisize+2
gkSfR[] init gisize+2

gkGrab1L[] init gisize+2
gkGrab1R[] init gisize+2
gkGrab2L[] init gisize+2
gkGrab2R[] init gisize+2
gkGrab3L[] init gisize+2
gkGrab3R[] init gisize+2
gkGrab4L[] init gisize+2
gkGrab4R[] init gisize+2
gkMorph[] init gisize+2
gkDev[] init gisize+2
gkDevFactAL[] init gisize+2
gkDevFactBL[] init gisize+2
gkDevFactAR[] init gisize+2
gkDevFactBR[] init gisize+2
gkDev1L[] init gisize+2
gkDev1R[] init gisize+2
gkDev2[] init gisize+2
gkdevenv init 0 ;use this to control filter output amp when devolve is on

opcode arrrot, k[], k[]k ;rotate array
    karr[], kshift xin       
    isize = lenarray(karr)
    kout[] init isize
    kcount = 0
        until kcount >= isize do
            kout[kcount] = karr[wrap(kcount+kshift,0,(isize-1))]        
            kcount += 1
        od
    xout kout
endop

opcode arrmorph, k[], kk[]k[]i ;morph two arrays
    kfact,k1[],k2[],isize xin
    kout[] init isize
        kout = k1*(1-kfact) + k2*kfact      
    xout kout
endop  

instr 1   ;live audio input and record/play control
kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

kliveon chnget "liveon"
kliveon port kliveon,.025
klivech chnget "livech"
kliveamp chnget "liveamp"

ainL,ainR ins
ainL=ainL*kliveon*kliveamp
ainR=ainR*kliveon*kliveamp
if klivech=1 then
gamicL=ainL
gamicR=ainR
else
gamicL=ainL+ainR
gamicR=ainL+ainR
endif

fftmicL pvsanal ainL,gisize,gisize*.25,gisize,1
fftmicR pvsanal ainR,gisize,gisize*.25,gisize,1
kmicframeL pvs2array gkMicL,fftmicL ;constantly writing fftL into an array gkBins so I can grab it
kmicframeR pvs2array gkMicR,fftmicR

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif
  
krgen chnget "rgen"
if changed(krgen)==1 then
 if krgen=1 then ;could add code here to set up ongoing changes with rate random within %range
  turnoff2 6,0,.05 ;turn off random array morphing instrument
  event "i",5,0,ksmps/sr ;turns on i5 for one k-rate period
  else
  turnoff2 5,0,.05
 endif
endif

kwalk chnget "walk"
if changed(kwalk)==1 then
 if kwalk=1 then
 turnoff2 7,0,0
 event "i",7,0,999999
 else 
 turnoff2 7,0,0
 endif
endif

kwreset chnget "wreset"
kwrate chnget "wrate"
if changed(kwreset)==1 then
 if kwreset=1 then
 turnoff2 8,0,0
 event "i",8,0,.01
 else 
 turnoff2 8,0,0
 endif
endif

kfilt chnget "filt"
if changed(kfilt)==1 then
 if kfilt=1 then
 turnoff2 20,0,0
 event "i",20,0,999999
 else
 turnoff2 20,0,0
 endif
endif

kgrab chnget "grab" ;i15 just grabs an FFT data stream and prints it--then freeze the current frame 
if changed(kgrab)==1 then
 if kgrab=1 then
 event "i",15,0,ksmps/sr ;capture one FFT frame and place in gkGrab[]
 turnoff2 16,0,0
 event "i",16,0,999999 ;i16 plays the frozen FFT data stream that was copied into gkGrab[]
 else
 turnoff2 16,0,.1
 endif
endif

kgrabs chnget "grabs" ;this is the streamed warp button
if changed(kgrabs)==1 then
 if kgrabs=1 then
 turnoff2 17,0,0
 event "i",17,0,999999
 else
 turnoff2 17,0,0
 endif
endif

kgrab1 chnget "grab1" ;i15 just grabs an FFT data stream and prints it
if changed(kgrab1)==1 then
 if kgrab1=1 then
 event "i",25,0,ksmps/sr ;capture one FFT frame and place in gkGrab[]
 endif
endif

kgrab2 chnget "grab2" ;i15 just grabs an FFT data stream and prints it
if changed(kgrab2)==1 then
 if kgrab2=1 then
 event "i",26,0,ksmps/sr ;capture one FFT frame and place in gkGrab[]
 endif
endif

kgrab3 chnget "grab3" ;i15 just grabs an FFT data stream and prints it
if changed(kgrab3)==1 then
 if kgrab3=1 then
 event "i",27,0,ksmps/sr ;capture one FFT frame and place in gkGrab[]
 endif
endif

kgrab4 chnget "grab4" ;i15 just grabs an FFT data stream and prints it
if changed(kgrab4)==1 then
 if kgrab4=1 then
 event "i",28,0,ksmps/sr ;capture one FFT frame and place in gkGrab[]
 endif
endif

kmorph chnget "morph" ;turns on and off morphing instrument
if changed(kmorph)==1 then
 if kmorph=1 then
 turnoff2 29,0,.1
 event "i",29,0,999999 ;morph turned on
 else
 turnoff2 29,0,.1
 endif
endif

kdevt chnget "devt"
if changed(kdevt)==1 then
 if kdevt=1 then
 turnoff2 30,0,0
 event "i",30,0,ksmps/sr
 else
 turnoff2 30,0,0
 endif
endif

kdevs chnget "dev"
if changed(kdevs)==1 then
 if kdevs=1 then
 turnoff2 30,0,0
 event "i",30,0,ksmps/sr
 else
 turnoff2 30,0,0
 turnoff2 31,0,0
 endif
endif

ktrace chnget "trace"
if changed(ktrace)==1 then
 if ktrace=1 then
 turnoff2 40,0,0
 event "i",40,0,999999
 else
 turnoff2 40,0,.1
 endif
endif

kfxon=kfilt+kgrab+kgrabs+kmorph+kdevs+kdevt+ktrace
kmicon=1-limit:k(kfxon,0,1)
gkmicsfenv portk kmicon,.01
outs gamicL*gkmicsfenv,gamicR*gkmicsfenv
endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
    if  gichnls==1 then
    a1  loscil 1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv
    gasfR=a1*kingain*kEnv
    elseif  gichnls==2 then
    a1,a2   loscil  1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv
    gasfR=a2*kingain*kEnv
    endif

;use chnset to turn off "sfplay" automatically IF "sfloop" is not on

fftsfL pvsanal gasfL,gisize,gisize*.25,gisize,1
fftsfR pvsanal gasfR,gisize,gisize*.25,gisize,1
ksfframeL pvs2array gkSfL,fftsfL ;constantly writing fftL into an array gkBins so I can grab it
ksfframeR pvs2array gkSfR,fftsfR
outs gasfL*gkmicsfenv,gasfR*gkmicsfenv
endin

instr 3
giTable ftgen 1,0,0,1,gSfilepath,0,0,0
gichnls filenchnls gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen init ftlen(giTable)/gichnls
Smessage sprintfk "file(%s)",gSfilepath
endin

instr 5 ;instrument that generates random tables on command
gkRandcurrent=gkNz ;load array used for maska FFT into current array
copya2ftab gkRandcurrent,201 ;write current array to f201
koffsetindex=0 ;generate new random table and load into target array
 until koffsetindex==gisize do
 gkRandtarget[koffsetindex] = random:k(0,1) ;generate random values between 0 and 1 iteratively into target array
 koffsetindex += 1
 od
copya2ftab gkRandtarget,202 ;write target array to f202 
kport chnget "port" ;turn on i6 to actually morph from current to target and write this data into gkNz
event "i",6,0,kport*2
endin

instr 6 ;instrument to morph two arrays
gkmorph line 0,p3,1 ;ramp from 0-1
gkNz arrmorph gkmorph,gkRandcurrent,gkRandtarget,gisize ;actual morphing from current to target
copya2ftab gkNz,200 ;write contents of active amp mask noise array into f200
;if changed(gkmorph)==1 then
cabbageSet "rand1","tableNumber",200
;endif
endin

instr 7 ;random "drunk" with an array
kwdepth chnget "wdepth"
kwrate chnget "wrate"

gktrig metro kwrate ;generate a trigger to do random calculation

if gktrig=1 then
 gkWcurrent=gkWalk
 copya2ftab gkWcurrent,301
 kindex=0
 until kindex==gisize do
 gkWtemp[kindex]=random:k(-kwdepth,kwdepth)
 kindex+=1
 od
gkWtarget=gkWtemp+gkWcurrent
gkWtarget limit gkWtarget,-.5,.5
copya2ftab gkWtarget,302
event "i",9,0,1/kwrate
endif
endin

instr 8 ;random walk reset to 0
kwrate chnget "wrate"
 kindex=0
 until kindex==gisize do
 gkWtarget[kindex]=0
 kindex+=1
 od
event "i",9,0,1/kwrate
endin

instr 9 ;instrument to morph two arrays
gkmorph2 line 0,p3,1 ;ramp from 0-1
gkWalk arrmorph gkmorph2,gkWcurrent,gkWtarget,gisize ;actual morphing from current to target
copya2ftab gkWalk,300 ;write contents of active amp mask noise array into f200
if changed(gkmorph)==1 then
cabbageSet "walktest","tableNumber",300
endif
endin

instr 10   ;filter array control

kLine[] init gisize ;creates an array for the base starting values
kSum[] init gisize ;array used to generate left channel amplitude mask
gkNz[] tab2array 200 ;creates array for noise function
kCos1[] init gisize ;harmonically tuned cosines
kCos2[] init gisize ;octave up
kCos3[] init gisize ;two octaves up
kCos4[] init gisize ;three octaves up
kCos[] init gisize ;mix the octavization tables together into this final cosine array
kFWin[] init gisize ;cosine to use as factor to overlay on cosines to control power to harmonics

istep=6.283185307179586/gisize ;2pi/FFT size used to step through cosine calculations, one cycle per array size
ibincps=sr/gisize ;Hz per bin in the FFT
kport chnget "port"
knzscale chnget "nzscale"
knzscale portk knzscale,kport
koffsetstart chnget "offsetstart"
koffsetstart portk koffsetstart,kport
koffsetend chnget "offsetend"
koffsetend portk koffsetend,kport
klineF chnget "lineF"
klineF portk klineF,kport
ksinF chnget "sinF"
ksinF portk ksinF,kport
ksinamp chnget "sinamp"
ksinamp portk ksinamp,kport
krotate chnget "rotate"
krotate portk krotate,kport
krgen chnget "rgen"
kwscale chnget "wscale"
kQ chnget "Q"
koct chnget "oct"
kwreset chnget "wreset"
kspread chnget "spread"
kctrh chnget "ctrh"

if changed(koffsetstart,koffsetend,knzscale,ksinF,ksinamp,krotate,klineF,krgen,gkmorph,gkmorph2,kwscale,gktrig,kQ,koct,kwreset,kspread,kctrh)==1 then
 klineincr=((koffsetend-koffsetstart)/gisize)*klineF
 koffsetindex=0
 ktemp=koffsetstart

 until koffsetindex==gisize do
kbinF=gisize/(ksinF/ibincps) ;desired fundamental cps/Hz per bin reaps cosine input multiplier

kFWin[koffsetindex] = cos(limit:k(((koffsetindex-((ksinF*kctrh)/ibincps))*(istep/kspread)*kbinF),-3.14159265,3.14159265))*.5+.5
kCos1[koffsetindex] = (cos(koffsetindex*kbinF*istep)*.5+.5)^kQ*ksinamp
kCos2[koffsetindex] = (cos(koffsetindex*kbinF*istep*.5)*.5+.5)^kQ*ksinamp ;one octave up
kCos3[koffsetindex] = (cos(koffsetindex*kbinF*istep*.25)*.5+.5)^kQ*ksinamp ;two octaves up
kCos4[koffsetindex] = (cos(koffsetindex*kbinF*istep*.125)*.5+.5)^kQ*ksinamp ;three octaves up

 kLine[koffsetindex] = ktemp
 ktemp += klineincr
 if klineincr>0 then
  if ktemp>koffsetend then
  ktemp=koffsetstart
  endif
 elseif klineincr<0 then
  if ktemp<koffsetend then
  ktemp=koffsetstart
  endif
 endif
 koffsetindex += 1
 od

;in here do koct calculations 
koct1=2-koct ;these simple calculations will provide amplitude ramps up and down for each octave array to be mixed
if koct1<0 then
koct1=0
endif
  koct2=koct-1
  if koct2>1 then
  koct2=3-koct
  elseif koct2<0 then
  koct2=0
  endif
koct3=koct-2
if koct3<0 then
koct3=0
elseif koct3>1 then
koct3=2-koct3
endif
  koct4=koct-3
  if koct4<0 then
  koct4=0
  endif

kCos=((kCos1*koct1)+(kCos2*koct2)+(kCos3*koct3)+(kCos4*koct4))*kFWin
kSum=kLine+((gkNz-.5)*knzscale)+kCos+(gkWalk*kwscale)

 kSum limit kSum,.0001,1
 kSum arrrot kSum,krotate*2048
 
 copya2ftab kSum,99 ;copies added arrays into f99 and 
 copya2ftab kCos,401
 event "i",11,0,.01
 event "i",12,0,.01
 endif
endin

instr 11 ;main LR table updater
cabbageSet "arraydisplayL","tableNumber",99
endin

instr 12
cabbageSet "cos","tableNumber",401
endin

instr 15 ;grabs one frame of bin data and stores in gkGrab[]
ksource chnget "frzsource" ;1=mic/line, 2=sf, 3=filt, 4=morph, 5=devolve, 6=trace
if ksource=1 then
gkGrabL=gkMicL ;grab the current frame of bin data
gkGrabR=gkMicR
elseif ksource=2 then
gkGrabL=gkSfL
gkGrabR=gkSfR
elseif ksource=3 then
gkGrabL=gkFiltL
gkGrabR=gkFiltR
elseif ksource=4 then
gkGrabL=gkMorphL
gkGrabR=gkMorphR
elseif ksource=5 then
gkGrabL=gkDevL
gkGrabR=gkDevR
elseif ksource=6 then
gkGrabL=gkTraceL
gkGrabR=gkTraceR
endif
endin

instr 16 ;this works to play the single frame of bin data stored in gkGrab[]
kwout chnget "wout"
kwarpsc chnget "warpsc"
kwarpsh chnget "warpsh"
kwarplo chnget "warplo"
kwarpmix chnget "warpmix"
ksource chnget "frzsource"
fgrabL pvsfromarray gkGrabL
fgrabR pvsfromarray gkGrabR
fwarpL pvswarp fgrabL,kwarpsc,kwarpsh,kwarplo
fwarpR pvswarp fgrabR,kwarpsc,kwarpsh,kwarplo
kfrzL pvs2array gkFrzL,fwarpL ;writes pvswarp frame output to a global array for use in other instruments
kfrzR pvs2array gkFrzR,fwarpR
gafreezeL pvsynth fwarpL
gafreezeR pvsynth fwarpR
if ksource=1 then ;just need this to mix with original source signal below 1=mic/line, 2=sf, 3=filt, 4=morph, 5=dev, 6=trace
aL=gamicL
aR=gamicR
elseif ksource=2 then
aL=gasfL
aR=gasfR
elseif ksource=3 then
aL=gafiltL
aR=gafiltR
elseif ksource=4 then
aL=gamorphL
aR=gamorphR
elseif ksource=5 then
aL=gadevL
aR=gadevR
elseif ksource=6 then
aL=gatraceL
aR=gatraceR
endif
outs (gafreezeL*kwarpmix)+((1-kwarpmix)*aL)*kwout,(gafreezeR*kwarpmix)+((1-kwarpmix)*aR)*kwout
endin

instr 17 ;this works to play streamed frames of bin data
kGrabsL[] init gisize+2
kGrabsR[] init gisize+2
kwout chnget "wout"
kwarpsc chnget "warpsc"
kwarpsh chnget "warpsh"
kwarplo chnget "warplo"
kwarpmix chnget "warpmix"
ksource chnget "frzsource" ;1=mic/line, 2=sf, 3=filter, 4=morph, 5=devolve, 6=trace
if ksource=1 then
kGrabsL=gkMicL
kGrabsR=gkMicR
elseif ksource=2 then
kGrabsL=gkSfL
kGrabsR=gkSfR
elseif ksource=3 then
kGrabsL=gkFiltL
kGrabsR=gkFiltR
elseif ksource=4 then
kGrabsL=gkMorphL
kGrabsR=gkMorphR
elseif ksource=5 then 
kGrabsL=gkDevL
kGrabsR=gkDevR
elseif ksource=6 then
kGrabsL=gkTraceL
kGrabsR=gkTraceR
endif
fgrabsL pvsfromarray kGrabsL
fgrabsR pvsfromarray kGrabsR
fwarpL pvswarp fgrabsL,kwarpsc,kwarpsh,kwarplo
fwarpR pvswarp fgrabsR,kwarpsc,kwarpsh,kwarplo
kfrzL pvs2array gkFrzL,fwarpL ;writes pvswarp frame output to a global array for use in other instruments
kfrzR pvs2array gkFrzR,fwarpR
gafreezeL pvsynth fwarpL
gafreezeR pvsynth fwarpR
if ksource=1 then ;just need this to mix with original source signal below 1=mic/line, 2=sf, 3=filt, 4=morph, 5=dev, 6=trace
aL=gamicL
aR=gamicR
elseif ksource=2 then
aL=gasfL
aR=gasfR
elseif ksource=3 then
aL=gafiltL
aR=gafiltR
elseif ksource=4 then
aL=gamorphL
aR=gamorphR
elseif ksource=5 then
aL=gadevL
aR=gadevR
elseif ksource=6 then
aL=gatraceL
aR=gatraceR
endif
outs (gafreezeL*kwarpmix)+((1-kwarpmix)*aL)*kwout,(gafreezeR*kwarpmix)+((1-kwarpmix)*aR)*kwout
endin

instr 20 ;actual filter instrument
kfmix chnget "fmix"
kfmix=sqrt(kfmix)
ksource chnget "filtsource" ;1=mic/line, 2=sf, 3=warp, 4=morph, 5=devolve, 6=trace
if ksource=1 then
aL=gamicL
aR=gamicR
elseif ksource=2 then
aL=gasfL
aR=gasfR
elseif ksource=3 then
aL=gafreezeL
aR=gafreezeR
elseif ksource=4 then
aL=gamorphL
aR=gamorphR
elseif ksource=5 then
aL=gadevL
aR=gadevR
elseif ksource=6 then
aL=gatraceL
aR=gatraceR
endif

klo chnget "lo"
klw chnget "lw"
khi chnget "hi"
khw chnget "hw"
fftL pvsanal aL,gisize,gisize*.25,gisize,1
fftR pvsanal aR,gisize,gisize*.25,gisize,1
kframe pvs2array gkBinsL,fftL ;constantly writing fftL into an array gkBins so I can grab it
kframeB pvs2array gkBinsR,fftR
fpanL pvsmaska fftL,99,1
fpanR pvsmaska fftR,99,1
filtL pvsbandp fpanL,klo,klw+klo,khi,khw+khi,2.3
filtR pvsbandp fpanR,klo,klw+klo,khi,khw+khi,2.3
kframe2 pvs2array gkFiltL,filtL ;writes filtL into an array gkFilr so I can grab it 
kframe2B pvs2array gkFiltR,filtR 
afftL pvsynth filtL
afftR pvsynth filtR
gafiltL=balance((aL*(1-kfmix))+(afftL*kfmix),aL) ;add "depth" control by mixing with input signal
gafiltR=balance((aL*(1-kfmix))+(afftR*kfmix),aR)
kfout chnget "fout"
outs gafiltL*kfout,gafiltR*kfout
;outs gafiltL*kmorph*kgrab*kdevenv*ktrace,gafiltR*kmorph*kgrab*kdevenv*ktrace
endin

instr 25 ;grabs one frame of bin data and stores in gkGrab1[]
ksource chnget "morphsource" ;1=mic/line, 2=sf, 3=filt, 4=warp, 5=devolve, 6=trace
if ksource=1 then
gkGrab1L=gkMicL ;grab the current frame of bin data
gkGrab1R=gkMicR
elseif ksource=2 then
gkGrab1L=gkSfL
gkGrab1R=gkSfR
elseif ksource=3 then
gkGrab1L=gkFiltL
gkGrab1R=gkFiltR
elseif ksource=4 then
gkGrab1L=gkFrzL
gkGrab1R=gkFrzR
elseif ksource=5 then
gkGrab1L=gkDevL
gkGrab1R=gkDevR
elseif ksource=6 then
gkGrab1L=gkTraceL
gkGrab1R=gkTraceR
endif
endin

instr 26 ;grabs one frame of bin data and stores in gkGrab2[]
ksource chnget "morphsource" ;1=mic/line, 2=sf, 3=filt, 4=warp, 5=devolve, 6=trace
if ksource=1 then
gkGrab2L=gkMicL ;grab the current frame of bin data
gkGrab2R=gkMicR
elseif ksource=2 then
gkGrab2L=gkSfL
gkGrab2R=gkSfR
elseif ksource=3 then
gkGrab2L=gkFiltL
gkGrab2R=gkFiltR
elseif ksource=4 then
gkGrab2L=gkFrzL
gkGrab2R=gkFrzR
elseif ksource=5 then
gkGrab2L=gkDevL
gkGrab2R=gkDevR
elseif ksource=6 then
gkGrab2L=gkTraceL
gkGrab2R=gkTraceR
endif
endin

instr 27 ;grabs one frame of bin data and stores in gkGrab3[]
ksource chnget "morphsource" ;1=mic/line, 2=sf, 3=filt, 4=warp, 5=devolve, 6=trace
if ksource=1 then
gkGrab3L=gkMicL ;grab the current frame of bin data
gkGrab3R=gkMicR
elseif ksource=2 then
gkGrab3L=gkSfL
gkGrab3R=gkSfR
elseif ksource=3 then
gkGrab3L=gkFiltL
gkGrab3R=gkFiltR
elseif ksource=4 then
gkGrab3L=gkFrzL
gkGrab3R=gkFrzR
elseif ksource=5 then
gkGrab3L=gkDevL
gkGrab3R=gkDevR
elseif ksource=6 then
gkGrab3L=gkTraceL
gkGrab3R=gkTraceR
endif
endin

instr 28 ;grabs one frame of bin data and stores in gkGrab4[]
ksource chnget "morphsource" ;1=mic/line, 2=sf, 3=filt, 4=warp, 5=devolve, 6=trace
if ksource=1 then
gkGrab4L=gkMicL ;grab the current frame of bin data
gkGrab4R=gkMicR
elseif ksource=2 then
gkGrab4L=gkSfL
gkGrab4R=gkSfR
elseif ksource=3 then
gkGrab4L=gkFiltL
gkGrab4R=gkFiltR
elseif ksource=4 then
gkGrab4L=gkFrzL
gkGrab4R=gkFrzR
elseif ksource=5 then
gkGrab4L=gkDevL
gkGrab4R=gkDevR
elseif ksource=6 then
gkGrab4L=gkTraceL
gkGrab4R=gkTraceR
endif
endin

instr 29 ;morph among 4 arrays
kenv adsr .1,.1,1,.1
kM12L[] init gisize+2
kM12R[] init gisize+2
kM34L[] init gisize+2
kM34R[] init gisize+2
kMixL[] init gisize+2
kMixR[] init gisize+2
kmout chnget "mout"
kmorphx chnget "morphx"
kmorphy chnget "morphy"
kM12L arrmorph kmorphx,gkGrab1L,gkGrab2L,gisize+2 ;morph grab 1 and 2
kM12R arrmorph kmorphx,gkGrab1R,gkGrab2R,gisize+2
kM34L arrmorph kmorphx,gkGrab3L,gkGrab4L,gisize+2 ;morph grab 3 and 4
kM34R arrmorph kmorphx,gkGrab3R,gkGrab4R,gisize+2
gkMorphL arrmorph kmorphy,kM34L,kM12L,gisize+2 ;morph grab 1-2 and 3-4
gkMorphR arrmorph kmorphy,kM34R,kM12R,gisize+2 ;writes to global so array can be read as input for other instruments
fMorphL pvsfromarray gkMorphL
fMorphR pvsfromarray gkMorphR
gamorphL pvsynth fMorphL ;resynthesize
gamorphR pvsynth fMorphR
outs gamorphL*kenv*kmout,gamorphR*kenv*kmout
endin

instr 30 ;grabs current frame, devolve time, and generates devolution factor arrays and then turns on i31 to actually devolve

kdtime chnget "dtime"
ksource chnget "devsource" ;1=mic/line, 2=sf, 3=filt, 4=warp, 5=morph, 6=trace
if ksource=1 then
gkDev1L=gkMicL ;grab the current frame of bin data if using a frozen frame rather than a stream
gkDev1R=gkMicR
elseif ksource=2 then
gkDev1L=gkSfL
gkDev1R=gkSfR
elseif ksource=3 then
gkDev1L=gkFiltL
gkDev1R=gkFiltR
elseif ksource=4 then
gkDev1L=gkFrzL
gkDev1R=gkFrzR
elseif ksource=5 then
gkDev1L=gkMorphL
gkDev1R=gkMorphR
elseif ksource=6 then
gkDev1L=gkTraceL
gkDev1R=gkTraceR
endif

kdminA chnget "dminA" ;min/max logic
kdmaxA chnget "dmaxA"
 if kdminA>kdmaxA then
 kdtempA=kdminA
 kdminA=kdmaxA
 kdmaxA=kdtempA
 endif
kdminF chnget "dminF"
kdmaxF chnget "dmaxF"
 if kdminF>kdmaxF then
 kdtempF=kdminF
 kdminF=kdmaxF
 kdmaxF=kdtempF
 endif

;;gkDevFactA
kdfind=0
until kdfind=gisize+2 do ;this creates an array filled with 1 as starting devolution array
gkDevFactAL[kdfind]=1
gkDevFactAR[kdfind]=1
kdfind+=1
od

kdamp chnget "damp"
kdf chnget "df"

;gkDevFactB
if kdamp=1 then
kdfAind=0
until kdfAind=gisize+2 do ;this creates random amp deviation target factor values
gkDevFactBL[kdfAind]=1+random:k(kdminA,kdmaxA)
gkDevFactBR[kdfAind]=1+random:k(kdminA,kdmaxA)
kdfAind+=2
od
else
kdfAind=0
until kdfAind=gisize+2 do ;this provides amp factor of 1
gkDevFactBL[kdfAind]=1
gkDevFactBR[kdfAind]=1
kdfAind+=2
od
endif

if kdf=1 then
kdfFind=1 
until kdfFind=gisize+1 do ;this creates target semitone deviation target factor values
gkDevFactBL[kdfFind]=semitone(random:k(kdminF,kdmaxF))
gkDevFactBR[kdfFind]=semitone(random:k(kdminF,kdmaxF))
kdfFind+=2
od
else
kdfFind=1 
until kdfFind=gisize+1 do ;this provides frequency factor of 1
gkDevFactBL[kdfFind]=1
gkDevFactBR[kdfFind]=1
kdfFind+=2
od
endif

kdevs chnget "dev"
kdevt chnget "devt"
if kdevs=1 then
turnoff2 31,0,0
event "i",31,0,999999
endif
if kdevt=1 then
turnoff2 31,0,0
event "i",31,0,kdtime
endif

endin

;will have problems if devolve is hit again while it is running--need to grab global arrays and make them local
;multiple instances won'tsound together as is--perhaps combine i30 and i31 and see fi I can get it to work that way??

instr 31 ;devolves amp and frequency from grabbed frame by usingarrays that morph from no deviation to random values
kMorphL[] init gisize+2
kMorphR[] init gisize+2
kDevFactAL[] init gisize+2
kDevFactAR[] init gisize+2
kDevFactBL[] init gisize+2
kDevFactBR[] init gisize+2
kDevL[] init gisize+2
kDevR[] init gisize+2
kDevFactAL=gkDevFactAL
kDevFactAR=gkDevFactAR
kDevFactBL=gkDevFactBL
kDevFactBR=gkDevFactBR
iad chnget "ad" ;attack and decay times
kdevmix chnget "devmix"
kdout chnget "dout"

ksource chnget "devsource" ;used for output mix with incoming signal
if ksource=1 then ;1=mic/line, 2=sf, 3=filter, 4=warp, 5=morph, 6=trace
aL=gamicL ;grab the current frame of bin data
aR=gamicR
elseif ksource=2 then
aL=gasfL
aR=gasfR
elseif ksource=3 then
aL=gafiltL
aR=gafiltR
elseif ksource=4 then
aL=gafreezeL
aR=gafreezeR
elseif ksource=5 then
aL=gamorphL
aR=gamorphR
elseif ksource=6 then
aL=gatraceL
aR=gatraceR
endif

;devolve single frame or stream
kfreeze chnget "freeze"
if kfreeze=1 then
kDevL=gkDev1L
kDevR=gkDev1R
else
 if ksource=1 then
 kDevL=gkMicL ;grab the current streamed frame of bin data
 kDevR=gkMicR
 elseif ksource=2 then
 kDevL=gkSfL
 kDevR=gkSfR
 elseif ksource=3 then
 kDevL=gkFiltL
 kDevR=gkFiltR
 elseif ksource=4 then
 kDevL=gkFrzL
 kDevR=gkFrzR
 elseif ksource=5 then
 kDevL=gkMorphL
 kDevR=gkMorphR
 elseif ksource=6 then
 kDevL=gkTraceL
 kDevR=gkTraceR
 endif
endif

kdir chnget "dir" ;forward, backward
klinex chnget "linex" ;linear, exponential, or manual
kmanual chnget "manual" ;manual value 0-1
kmanport chnget "manport"
kmanual portk kmanual,kmanport
kexp chnget "exp" ;sharpness of exponential curve, values .25-4

if kdir=1 then
kline line 0,p3,1
else
kline line 1,p3,0
endif

if klinex=1 then
kline=kline
elseif klinex=2 then
kline=kline^kexp
elseif klinex=3 then
kline=kmanual
endif

kMorphL arrmorph kline,kDevFactAL,kDevFactBL,gisize+2
kMorphR arrmorph kline,kDevFactAR,kDevFactBR,gisize+2
gkMorphL=kDevL*kMorphL ;multiplies amp and freq data with morphing array kMorph
gkMorphR=kDevR*kMorphR ;output is global so frame from array can be used by other instruments
fDevolveL pvsfromarray gkMorphL
fDevolveR pvsfromarray gkMorphR
gadevL pvsynth fDevolveL
gadevR pvsynth fDevolveR

gkdevenv linseg 0,iad,1,p3-(2*iad),1,iad,0
gadevL+=gadevL*gkdevenv
gadevR+=gadevR*gkdevenv
outs (gadevL*kdevmix)+((1-kdevmix)*aL)*kdout,(gadevR*kdevmix)+((1-kdevmix)*aR)*kdout
endin

instr 40 ;trace instrument, spawns instances of i41 with crossfades
ktbins chnget "tbins"
kgrdur chnget "grdur"
koverlap chnget "overlap"
ksource chnget "tracesource" ;1=mic/line, 2=sf, 3=filter, 4=warp, 5=morph, 6=devolve
ktrand chnget "trand"
if ksource=1 then
aL=gamicL
aR=gamicR
elseif ksource=2 then
aL=gasfL
aR=gasfR
elseif ksource=3 then
aL=gafiltL
aR=gafiltR
elseif ksource=4 then
aL=gafreezeL
aR=gafreezeR
elseif ksource=5 then
aL=gamorphL
aR=gamorphR
elseif ksource=6 then
aL=gadevL
aR=gadevR
endif
ktmix chnget "tmix"
ktout chnget "tout"
gatraceinL=aL ;send audio signal to i41 to use for balance
gatraceinR=aR
outs gatraceinL*(1-ktmix)*ktout,gatraceinR*(1-ktmix)*ktout ;use this to output trace input into audio mix instead of in i41

gftraceL pvsanal aL,gisize,gisize*.25,gisize,1 ;create a single global fsignal input for i41, save on cpu
gftraceR pvsanal aR,gisize,gisize*.25,gisize,1
;then write gatrace output into an array for other effects to use
fftraceL pvsanal gatraceL,gisize,gisize*.25,gisize,1
fftraceR pvsanal gatraceR,gisize,gisize*.25,gisize,1
ktraceframeL pvs2array gkTraceL,fftraceL ;constantly writing fftL into an array gkBins so I can grab it
ktraceframeR pvs2array gkTraceR,fftraceR

kampfact=1/koverlap
krate=(1/kgrdur)*koverlap
krrand randh krate*ktrand,krate
ktrig metro krate+krrand ;OLD VERSION WITHOUT RANDOM ---> ktrig metro (1/kgrdur)*koverlap
krdur randh kgrdur*ktrand,krate+krrand
if ktrig=1 then
event "i",41,0,kgrdur+krdur,ktbins,kampfact
endif
endin

instr 41 ;one instance of trace per each grain
ktout chnget "tout"
kline line 0,p3,1
kenv tablei kline,25,1 ;reads through sinusoidal envelope function
ktmix chnget "tmix"
ftraceL pvstrace gftraceL,p4 ;number of bins in i40
ftraceR pvstrace gftraceR,p4
atraceL pvsynth ftraceL
atraceR pvsynth ftraceR
atraceL balance atraceL,gatraceinL*p5 ;p5=1/overlap
atraceR balance atraceR,gatraceinR*p5
gatraceL+=(atraceL*kenv*ktout*ktmix)
gatraceR+=(atraceR*kenv*ktout*ktmix)
outs gatraceL,gatraceR
endin

instr 600	; record file
irecch chnget "recch"
krsource chnget "rsource"
if krsource=1 then
afinalL=gafiltL
afinalR=gafiltR
elseif krsource=2 then
afinalL=gafreezeL
afinalR=gafreezeR
elseif krsource=3 then
afinalL=gamorphL
afinalR=gamorphR
elseif krsource=4 then
afinalL=gadevL
afinalR=gadevR
elseif krsource=5 then
afinalL=gatraceL
afinalR=gatraceR
elseif krsource=6 then
afinalL=gamicL
afinalR=gamicR
elseif krsource=7 then
afinalL=gasfL
afinalR=gasfR
endif

ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname  sprintf "SFilter_%s", Sfilnam
 gSnameL  sprintf "SFilterL_%s", Sfilnam
 gSnameR  sprintf "SFilterR_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(afinalL+afinalR)*.7
  elseif irecch=2 then
   fout gSname,imode,afinalL,afinalR
  elseif irecch=3 then
   fout gSname,imode,afinalL,afinalR
   fout gSnameL,imode,afinalL
   fout gSnameR,imode,afinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play" ;figure out how to set the value of "play" to 0
endin

instr 700
clear gamicL,gamicR,gasfL,gasfR,gafiltL,gafiltR,gafreezeL,gafreezeR,gamorphL,gamorphR,gadevL,gadevR,gatraceL,gatraceR ;gafinalL,gafinalR,
endin

</CsInstruments>

<CsScore>
f0 z ;causes Csound to run infinitely
f25 0 32768 19 1 .5 270 .5 ;provides a sinusoid window function for i41

f99 0 2048 10 0 ;this is a null table created to display arrays--arrays are loaded into it, L channel amps

f200 0 2048 21 1 ;uniform random 0-1, initial random table, overwritten by i5, file used for FFT amp masking
f201 0 2048 10 0 ;current random table
f202 0 2048 10 0 ;target random table

f300 0 2048 10 0 ;target table for drunk random walk
f301 0 2048 10 0 ;current random table
f302 0 2048 10 0 ;target random table

f400 0 2048 10 0 ;target table for harmonic filter
f401 0 2048 10 0 ;target table for cos filter display

f500 0 2048 10 0 ;target table for writing spectral data

i1 0 999999     ;mic, sf, effect on/off management
;i5 ;generates random table, triggers i6
;i6 ;morphs from current random to target random at portamento time
;i7 0 10 ;random walk
;i8 ;random walk clear to 0--no morphing
;i9 ;morph from current random walk table to the next one
i10 0 999999    ;live array management 
;i11 ;displays main filter to ftable
;i12 ;displays harmonic filter to ftable
;i15 ;fft freeze instrument
;i20 0 999999    ;FFT filter instrument
i700 0 999999   ;global audio clear

</CsScore>
</CsoundSynthesizer>
